Count the Number of Good Partitions | Intuition | Leetcode-2963 | Weekly Contest 375
Whatsapp Community Link : https://www.whatsapp.com/channel/0029Va6kVSjICVfiVdsHgi1A
This is the 6th Video of our "2-Pointers" Playlist.
In this video we will try to solve an easy problem - Count the Number of Good Partitions (Leetcode - 2963).
Asked today on 10th Dec, 2023 in Leetcode Weekly Contest 375
I will explain the intuition so easily that you will never forget and start seeing this as cakewalk EASYYY.
We will do live coding after explanation and see if we are able to pass all the test cases.
Also, please note that my Github solution link below contains both C++ as well as JAVA code.
Problem Name : Count the Number of Good Partitions
Company Tags : Will soon update
My solutions on Github(C++ & JAVA) : https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/Arrays/Two%20Pointer/Count%20the%20Number%20of%20Good%20Partitions.cpp
Leetcode Link : https://leetcode.com/problems/count-the-number-of-good-partitions
My DP Concepts Playlist : https://youtu.be/7eLMOE1jnls
My Graph Concepts Playlist : https://youtu.be/5JGiZnr6B5w
My GitHub Repo for interview preparation : https://github.com/MAZHARMIK/Interview_DS_Algo
Subscribe to my channel : https://www.youtube.com/@codestorywithMIK
Instagram : https://www.instagram.com/codestorywithmik/
Facebook : https://www.facebook.com/people/codestorywithmik/100090524295846/
Twitter : https://twitter.com/CSwithMIK
Approach Summary :
The approach involves iterating through the elements of the input vector, maintaining a hash map (unordered_map in C++) to store the last index of each number encountered. The algorithm then iterates through the vector again, updating a variable j to store the maximum index encountered so far. Whenever the current index i surpasses j, a new partition is identified, and the result is multiplied by 2 (modulo M) to account for the partition possibilities. The final result represents the total number of good partitions, and the function returns this result. The code utilizes modular arithmetic with a constant M = 1e9 + 7 to avoid integer overflow.
╔═╦╗╔╦╗╔═╦═╦╦╦╦╗╔═╗
║╚╣║║║╚╣╚╣╔╣╔╣║╚╣═╣
╠╗║╚╝║║╠╗║╚╣║║║║║═╣
╚═╩══╩═╩═╩═╩╝╚╩═╩═╝
✨ Timelines✨
00:00 - Introduction
#coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge #leetcodequestions #leetcodechallenge #hindi #india #coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge#leetcodequestions #leetcodechallenge #hindi #india #hindiexplanation #hindiexplained #easyexplaination #interview#interviewtips #interviewpreparation #interview_ds_algo #hinglish #github #design #data #google #video #instagram #facebook #leetcode #computerscience #leetcodesolutions #leetcodequestionandanswers #code #learning #dsalgo #dsa